#include "pch.h"

#include "FTNStruc.hpp"
#include "Common.hpp"
#include "Misc.hpp"
#include "Temp.hpp"
#include "BSO.hpp"


CBSOManager::CBSOManager() {
	int	i, j, k, l;
    
	// prepare BSO directories

	for (i = 0, j = -1, k = -1, l = -1; g_vars.m_szBinkOutboundPath[i] != _T('\0'); i++) {
		if (g_vars.m_szBinkOutboundPath[i] == _T('\\')) {
			k = j;
			j = i;
		}
		if (g_vars.m_szBinkOutboundPath[i] == _T('.'))
		l = i;
	}

	k++;
	lstrcpyn( m_szBaseDir, g_vars.m_szBinkOutboundPath, k+1 );
	i = lstrlen( g_vars.m_szBinkOutboundPath );
	if (l < k)
		l = i-1;
	lstrcpyn( m_szDefaultDomainDir, g_vars.m_szBinkOutboundPath, l+1 );
	*m_szName  = _T('\0');
	m_iNameLen = 0;

	m_iNumberOfBaseDirNames = GetNumberOfEnclosedNames(m_szBaseDir);
}

CBSOManager::~CBSOManager() {
}

void CBSOManager::SetAddress(SFTNAddress &Addr) {
    // check another domain
    if (*Addr.Domain != _T('\0') && g_vars.m_fCheckDomainInBSO && 
        lstrcmpi( g_vars.m_addrMain.Domain, Addr.Domain ) != 0)
    {	    
        wsprintf( m_szName, _T("%s%s.%03x\\"), m_szBaseDir, Addr.Domain, Addr.Zone );
    }
    else {
        // check zone
        if (g_vars.m_addrMain.Zone != Addr.Zone) {
            wsprintf( m_szName, _T("%s.%03x\\"), m_szDefaultDomainDir, Addr.Zone );
        }
        else
            lstrcpy( m_szName, g_vars.m_szBinkOutboundPath );
    }

    m_iNameLen = lstrlen( m_szName );
    if (Addr.Point != 0) {
        wsprintf( m_szName + m_iNameLen, _T("%04x%04x.pnt\\"), Addr.Net, Addr.Node );
        m_iNameLen += 13;
    }

    MakeDirStructure( m_szName, m_iNumberOfBaseDirNames );

    if (Addr.Point != 0)
        wsprintf( m_szName + m_iNameLen, _T("%08x."), Addr.Point );
    else
        wsprintf( m_szName + m_iNameLen, _T("%04x%04x."), Addr.Net, Addr.Node );

    m_iNameLen = lstrlen(m_szName);
}

int CBSOManager::SetBusyFlag() {
    static TCHAR	szBusyFileName[MAX_PATH];
    HANDLE		hBusyFile;

    lstrcpy( szBusyFileName, m_szName );
    lstrcpy( m_szName + m_iNameLen, _T("tmp") );
    hBusyFile = GetTempFile( m_szName, GENERIC_WRITE );
    if (hBusyFile == INVALID_HANDLE_VALUE)
        return (0);
    CloseHandle(hBusyFile);
    lstrcpy( szBusyFileName + m_iNameLen, _T("bsy") );
    if (_trename( m_szName, szBusyFileName ) != 0) {
        _tremove( m_szName );
        return (0);
    }    
    return (1);
    
}

int CBSOManager::ClearBusyFlag() {
    lstrcpy( m_szName + m_iNameLen, _T("bsy") );
    return(_tremove(m_szName) == 0);
}

bool CBSOManager::IsBusyFlagExist() {
	if (SetBusyFlag()) {
		ClearBusyFlag();
		return (false);
	}
	return (true);
}
