#ifndef __ADRENALIN__LINKS__HEADER__
#define __ADRENALIN__LINKS__HEADER__

#include "FTNStruc.hpp"
#include "Flag.h"
#include "CfgParse.hpp"
#include "Common.hpp"


const		PASSWORD_SIZE     = 16;
const int	MAIN_ADDRESS      = -1;
const int	UNDEFINED_ADDRESS = -2;

struct SLink {
	/* The address of the link
	 */
	SFTNAddress   	m_addr;
	/* We will use this address while interchange data (index in AKA array)
	 */
	int		m_iOurAddr;
	/* Password
	 */
	TCHAR          	m_szPassword[PASSWORD_SIZE];

	int           	m_nActivity;
	int           	m_nRouteType;
	int           	m_nBSOType;

	int           	m_nPriority;
	unsigned long 	m_ulGroups;

	CFlag          	m_fAllowAreaCreation;
	TCHAR		m_szAutoCreatedPathName[MAX_PATH];
	unsigned long 	m_ulDefaultGroup;

	TCHAR		m_szCfgFileName[MAX_PATH];
	int           	m_nLine;

	TCHAR		m_szAvailAreasFileName[MAX_PATH];
	TCHAR		m_szRobotName[36];
};

typedef	vector<SLink>	VLinks;


class CLinks {
public:
	CLinks();
	~CLinks();

	bool	Select(const SFTNAddress& selAddr);
	bool	SelectFirst();
	bool	SelectNext();

	bool	IsSelected() const { return (m_itLink != m_vLinks.end()); }
	SLink&	GetSelected() const { return (*m_itLink); }

	void	Add(SLink link);
private:
	VLinks			m_vLinks;
	VLinks::iterator	m_itLink;
};

#endif

